﻿using System;
using System.Collections.Generic;
using System.ComponentModel;

namespace ProjectAtelier.Entities;

public class Order
{
    public int Id { get; private set; }

    [DisplayName("Дата заказа")]
    public DateTime DataTime { get; private set; }

    [DisplayName("Статус заказа")]
    public OrderStatus Status { get; private set; }

    [DisplayName("Характеристика")]
    public string Characteristic { get; private set; } = string.Empty;


    [DisplayName("Изделия")]
    public string Products => OrderProduct != null ?
        string.Join(", ", OrderProduct.Select(x => $"{x.ProductName} {x.Count}")) : string.Empty;

    [Browsable(false)]
    public IEnumerable<OrderProduct> OrderProduct { get; private set; } = [];


    [Browsable(false)]
    public int IdClient { get; private set; }
    [DisplayName("Имя клиента")]
    public string NameClient { get; private set; } = string.Empty;

    public static Order CreateOperation(int id, OrderStatus status, string characteristic, IEnumerable<OrderProduct> orderProduct, int idClient, DateTime dateTime)
    {
        return new Order
        {
            Id = id,
            DataTime = dateTime,
            Status = status,
            Characteristic = characteristic,
            OrderProduct = orderProduct,
            IdClient = idClient
        };
    }
    public void SetProductMaterial(IEnumerable<OrderProduct> orderProduct)
    {
        if (orderProduct != null && orderProduct.Any())
        {
            OrderProduct = orderProduct;
        }
    }
}